import glob
import pandas as pd

#directory containing fasta files
listoffiles = glob.glob("Directory containing fasta files")
frames = []
#all contig headers of SPAdes assembly in a dataframe
for file in listoffiles:
    output_1 = file.replace("E:\\Joep\\incremental_before_rr\\", "")
    output_2 = output_1.replace(".fasta", "")
    rij_1 = []
    rij_2 = []
    with open(file) as f:
        for line in f:
            if line.startswith(">"):
                rij_1.append(output_2)
                line_correct = line.replace("\n", "")
                rij_2.append(line_correct)
    df = pd.DataFrame(list(zip(rij_1, rij_2)), columns =['filename', 'Contig'])
    df["Contig"] = df["Contig"].str.replace(">", "")
    new = df["Contig"].str.split("_", n=5, expand=True)
    df["Node"] = new[0]
    df["Contig_number"] = new[1]
    df["lengthtekst"] = new[2]
    df["length"] = new[3]
    df["covtekst"] = new[4]
    df["kmer_coverage"] = new[5]
    df.drop(columns=["Node", "lengthtekst", "covtekst"], inplace=True)
    df["length"] = df["length"].astype(str).astype(int)
    df["kmer_coverage"] = pd.to_numeric(df["kmer_coverage"])
    frames.append(df)

df_total = pd.concat(frames)
#grouping dataframe per assembly and only containing contigs >1000
group_long = df_total[df_total["length"] > 10000].groupby("filename")

#from dataframe as contstructed above give median coverage as defined by Antipov et al (10)
def median_cov_calc(f):
    med_c_df = []
    names = []
    for name, group in f:
        total_length = group["length"].sum()
        half_length = total_length * 0.5
        length = 0
        for t in range(0, 100000):
            r = group.nlargest(t, "kmer_coverage")
            s = r.reset_index()
            if length > half_length:
                f = t - 2
                median_cov = s["kmer_coverage"].iloc[f]
                med_c_df.append(median_cov)
                names.append(name)
                break
            else:
                length = s["length"].sum()
                continue

    calc_median_cov = pd.DataFrame(list(zip(med_c_df, names)), columns=["calculated_median_coverage_all_contigs", "filename"])
    return calc_median_cov

#create dataframe containing all median coverages
df_median_medium = median_cov_calc(group_long)